serialization = require('serialization')

function item_to_key(item, damage, amount)
  if item.name then
    return item.name .. "|" .. math.floor(item.damage)
  else
    if amount then
      return item .. "|" .. math.floor(damage) .. "*" .. math.floor(amount)
    else
      return item .. "|" .. math.floor(damage)
    end
  end
end

function key_to_item(key)
  local item = {}
  local field = {}
  local i = 1

  for s in string.gmatch(key, "[^|]+") do
    field[i] = s
    i = i + 1
  end

  if i ~= 3 then
    print("Item key '" .. key .. "' is not valid.")
    os.exit()
  end

  item.name = field[1]

  i = 1
  for s in string.gmatch(field[2], "[^*]+") do
    field[i] = s
    i = i + 1
  end

  if i == 2 then
    item.damage = tonumber(field[1])
  elseif i == 3 then
    item.damage = tonumber(field[1])
    item.amount = tonumber(field[2])
  else
    print("Item key '" .. key .. "' is not valid.")
  end

  return item
end

function variable_to_string(variable)
  return tostring(serialization.serialize(variable))
end
