local event = require('event')
local thread = require('thread')

local D = loadfile('me_processor_lib/debug.lua')()

local threads = {}
local main_tid = {}
local crashed = false

-- Any error in a thread will take the whole system down.
local function thread_error(message)
  print()
  print("---- Thread error ----")
  print(message)
  print(debug.traceback())
  print()

  crashed = true

  if (thread.current() == main_tid) then
    print("Main thread crash.")
    print()
  end

  -- I... Want to kill... Everybody in the world... I want to eat your heart...  --SKRILLEX
  print("Killing all threads...")

  for n, tid in pairs(threads) do
    if (tid == main_tid) then
      print(tostring(tid) .. " main()")
    elseif (tid ~= thread.current()) then
      print(tostring(tid) .. " Killed")
      tid:kill()
      table.remove(threads, tid)
    else
      print(tostring(tid) .. " Me")
    end
  end

  if (thread.current() ~= main_tid) then
    -- If we ain't main, then main() goes bye bye now!
    main_tid:kill()
    table.remove(threads, main_tid)
  end

print("Should be 1 thread left.")
D.pv(threads)
table.remove(threads, thread.current())
print("Should be 0 threads left.")
D.pv(threads)

  print()
  print("So Long, and Thanks for All the Fish...")
end

local function thread_stub(thread_function, ...)
  -- Yield to caller.
  os.sleep(0)
  xpcall(thread_function, thread_error, table.unpack({...}))
  table.remove(threads, thread.current())
end

local function start_thread(thread_function, ...)
  local tid = thread.create(thread_stub, thread_function, table.unpack({...}))
  table.insert(threads, tid)
  return tid
end

return {
  run_main_thread = function(main, args)
    if THREADING then
      main_tid = start_thread(main, args)

      while not crashed and main_tid:status() == "running" do
        thread.waitForAny(main_tid, 1)
      end
    else
      main(args)
    end

    print("Program exit.")
  end,

  create = function(thread_function, ...)
    if THREADING then
      start_thread(thread_function, table.unpack({...}))
    else
      thread_function(unpack({...}))
    end
  end,

  sleep = function(time)
    -- FIXME: remove after thread checking works.
    -- Negative sleeps are zero sleeps as they should be... Right?
    os.sleep(time)

    --FIXME: Implement a thread checker like this below.
    --       Would be nice if we could print error messages if they exit uncleanly.
    --       Also a watchdog for the recycler would be nice, to detect recycler hangs.
    --local timeout = next_update - computer.uptime()
    --timeout = (timeout < 0 and 0 or timeout)
    --timeout = (timeout >= 1 and 1 or timeout)
    --thread.waitForAny(threads, timeout)
    --    ^^^ do we still need that after we threadified main?
  end
}
